/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.PricingMercadoDAO;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingMercado;
import com.rjconsultores.ventaboletos.service.PricingMercadoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Rafius
 */
@Service("pricingMercadoService")
public class PricingMercadoServiceImpl implements PricingMercadoService {

    @Autowired
    private PricingMercadoDAO pricingMercadoDAO;

    public List<PricingMercado> obtenerTodos() {
        return pricingMercadoDAO.obtenerTodos();
    }

    public PricingMercado obtenerID(Integer id) {
        return pricingMercadoDAO.obtenerID(id);
    }

    @Transactional
    public PricingMercado suscribir(PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingMercadoDAO.suscribir(entidad);
    }

    @Transactional
    public PricingMercado actualizacion(PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingMercadoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingMercado entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.EXCLUIDO);

        pricingMercadoDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingMercado(Pricing pricing, Parada origen, Parada destino) {
        return pricingMercadoDAO.obtenerPricingMercado(pricing, origen, destino);
    }

	@Override
	@Transactional
	public void borrar(List<PricingMercado> pricingMercados) {
		if(pricingMercados != null && !pricingMercados.isEmpty()) {
			for (PricingMercado pricingMercado : pricingMercados) {
				borrar(pricingMercado);
			}
		}
	}
	
}
